/* Util.c generated by valac 0.48.12, the Vala compiler
 * generated from Util.vala, do not modify */

/*
 * Copyright 2011-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */

#include <glib.h>
#include <float.h>
#include <math.h>
#include <libical-glib/libical-glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <libedataserver/libedataserver.h>
#include <libecal/libecal.h>
#include <time.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_ECalComponentId_free0(var) ((var == NULL) ? NULL : (var = (_vala_ECalComponentId_free (var), NULL)))
typedef struct _UtilResetTimerData UtilResetTimerData;

#define SERVICES_CALENDAR_TYPE_CALENDAR_MODEL (services_calendar_calendar_model_get_type ())
#define SERVICES_CALENDAR_CALENDAR_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SERVICES_CALENDAR_TYPE_CALENDAR_MODEL, ServicesCalendarCalendarModel))
#define SERVICES_CALENDAR_CALENDAR_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SERVICES_CALENDAR_TYPE_CALENDAR_MODEL, ServicesCalendarCalendarModelClass))
#define SERVICES_CALENDAR_IS_CALENDAR_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SERVICES_CALENDAR_TYPE_CALENDAR_MODEL))
#define SERVICES_CALENDAR_IS_CALENDAR_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SERVICES_CALENDAR_TYPE_CALENDAR_MODEL))
#define SERVICES_CALENDAR_CALENDAR_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SERVICES_CALENDAR_TYPE_CALENDAR_MODEL, ServicesCalendarCalendarModelClass))

typedef struct _ServicesCalendarCalendarModel ServicesCalendarCalendarModel;
typedef struct _ServicesCalendarCalendarModelClass ServicesCalendarCalendarModelClass;

struct _UtilResetTimerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
};

extern gboolean util_has_scrolled;
gboolean util_has_scrolled = FALSE;
extern GeeHashMap* util_providers;
GeeHashMap* util_providers = NULL;
extern ServicesCalendarCalendarModel* planner_calendar_model;

GDateTime* util_get_start_of_month (GDateTime* date);
GDateTime* util_strip_time (GDateTime* datetime);
GTimeZone* util_timezone_from_ical (ICalTime* date);
GDateTime* util_ical_to_date_time (ICalTime* date);
gboolean util_is_the_all_day (GDateTime* dtstart,
                              GDateTime* dtend);
void util_set_event_calendar_color (ESourceCalendar* cal,
                                    GtkWidget* widget);
guint util_source_hash_func (ESource* key);
gboolean util_calcomponent_equal_func (ECalComponent* a,
                                       ECalComponent* b);
static void _vala_ECalComponentId_free (ECalComponentId* self);
gint util_calcomponent_compare_func (ECalComponent* a,
                                     ECalComponent* b);
gboolean util_calcomp_is_on_day (ECalComponent* comp,
                                 GDateTime* day);
gboolean util_source_equal_func (ESource* a,
                                 ESource* b);
static void util_reset_timer_data_free (gpointer _data);
void util_reset_timer (GAsyncReadyCallback _callback_,
                       gpointer _user_data_);
void util_reset_timer_finish (GAsyncResult* _res_);
static gboolean util_reset_timer_co (UtilResetTimerData* _data_);
static gboolean __lambda1017_ (void);
static gboolean ___lambda1017__gsource_func (gpointer self);
gchar* util_get_source_location (ESource* source);
GType services_calendar_calendar_model_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ServicesCalendarCalendarModel, g_object_unref)
ESourceRegistry* services_calendar_calendar_model_get_registry (ServicesCalendarCalendarModel* self);

GDateTime*
util_get_start_of_month (GDateTime* date)
{
	GDateTime* _tmp1_;
	GDateTime* result = NULL;
	if (date == NULL) {
		GDateTime* _tmp0_;
		_tmp0_ = g_date_time_new_now_local ();
		_g_date_time_unref0 (date);
		date = _tmp0_;
	}
	_tmp1_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), 1, 0, 0, (gdouble) 0);
	result = _tmp1_;
	_g_date_time_unref0 (date);
	return result;
}

GDateTime*
util_strip_time (GDateTime* datetime)
{
	GDateTime* _tmp0_;
	GDateTime* result = NULL;
	g_return_val_if_fail (datetime != NULL, NULL);
	_tmp0_ = g_date_time_add_full (datetime, 0, 0, 0, -g_date_time_get_hour (datetime), -g_date_time_get_minute (datetime), (gdouble) (-g_date_time_get_second (datetime)));
	result = _tmp0_;
	return result;
}

/**
     * Converts the given ICal.Time to a DateTime.
     */
static const gchar*
string_offset (const gchar* self,
               glong offset)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = (const gchar*) (((gchar*) self) + offset);
	return result;
}

GTimeZone*
util_timezone_from_ical (ICalTime* date)
{
	ICalTimezone* timezone = NULL;
	gchar* tzid = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp15_ = FALSE;
	ICalTimezone* _tmp16_;
	ICalTimezone* _tmp19_;
	gint is_daylight = 0;
	gint interval = 0;
	ICalTimezone* _tmp21_;
	gint _tmp22_ = 0;
	gint _tmp23_;
	gboolean is_positive = FALSE;
	gint hours = 0;
	gint minutes = 0;
	const gchar* _tmp24_ = NULL;
	gchar* hour_string = NULL;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	GTimeZone* _tmp27_;
	GTimeZone* result = NULL;
	g_return_val_if_fail (date != NULL, NULL);
	if (i_cal_time_is_date (date)) {
		GTimeZone* _tmp0_;
		g_debug ("Util.vala:43: Given date is 'DATE' type, not 'DATE_TIME': Using timezo" \
"ne UTC");
		_tmp0_ = g_time_zone_new_utc ();
		result = _tmp0_;
		return result;
	}
	timezone = NULL;
	_tmp1_ = i_cal_time_get_tzid (date);
	_tmp2_ = g_strdup (_tmp1_);
	tzid = _tmp2_;
	_tmp3_ = tzid;
	if (_tmp3_ != NULL) {
		gchar* prefix = NULL;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp4_ = g_strdup ("/freeassociation.sourceforge.net/");
		prefix = _tmp4_;
		_tmp5_ = tzid;
		_tmp6_ = prefix;
		if (g_str_has_prefix (_tmp5_, _tmp6_)) {
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			const gchar* _tmp11_;
			GTimeZone* _tmp12_;
			_tmp7_ = tzid;
			_tmp8_ = prefix;
			_tmp9_ = strlen (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = string_offset (_tmp7_, (glong) _tmp10_);
			_tmp12_ = g_time_zone_new (_tmp11_);
			result = _tmp12_;
			_g_free0 (prefix);
			_g_free0 (tzid);
			return result;
		} else {
			const gchar* _tmp13_;
			GTimeZone* _tmp14_;
			_tmp13_ = tzid;
			_tmp14_ = g_time_zone_new (_tmp13_);
			result = _tmp14_;
			_g_free0 (prefix);
			_g_free0 (tzid);
			return result;
		}
		_g_free0 (prefix);
	}
	_tmp16_ = timezone;
	if (_tmp16_ == NULL) {
		ICalTimezone* _tmp17_;
		_tmp17_ = i_cal_time_get_timezone (date);
		_tmp15_ = _tmp17_ != NULL;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		ICalTimezone* _tmp18_;
		_tmp18_ = i_cal_time_get_timezone (date);
		timezone = _tmp18_;
	}
	_tmp19_ = timezone;
	if (_tmp19_ == NULL) {
		GTimeZone* _tmp20_;
		g_debug ("Util.vala:82: Date has no timezone info: defaulting to UTC");
		_tmp20_ = g_time_zone_new_utc ();
		result = _tmp20_;
		_g_free0 (tzid);
		return result;
	}
	_tmp21_ = timezone;
	_tmp23_ = i_cal_timezone_get_utc_offset (_tmp21_, date, &_tmp22_);
	is_daylight = _tmp22_;
	interval = _tmp23_;
	is_positive = interval >= 0;
	interval = abs (interval);
	hours = interval / 3600;
	minutes = (interval % 3600) / 60;
	if (is_positive) {
		_tmp24_ = "+";
	} else {
		_tmp24_ = "-";
	}
	_tmp25_ = g_strdup_printf ("%s%02d:%02d", _tmp24_, hours, minutes);
	hour_string = _tmp25_;
	_tmp26_ = hour_string;
	_tmp27_ = g_time_zone_new (_tmp26_);
	result = _tmp27_;
	_g_free0 (hour_string);
	_g_free0 (tzid);
	return result;
}

/**
     * Converts the given ICal.Time to a DateTime.
     * XXX : Track next versions of evolution in order to convert ICal.Timezone to GLib.TimeZone with a dedicated function…
     */
GDateTime*
util_ical_to_date_time (ICalTime* date)
{
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gint second = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GTimeZone* _tmp6_;
	GTimeZone* _tmp7_;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	GDateTime* result = NULL;
	g_return_val_if_fail (date != NULL, NULL);
	i_cal_time_get_date (date, &_tmp0_, &_tmp1_, &_tmp2_);
	year = _tmp0_;
	month = _tmp1_;
	day = _tmp2_;
	i_cal_time_get_time (date, &_tmp3_, &_tmp4_, &_tmp5_);
	hour = _tmp3_;
	minute = _tmp4_;
	second = _tmp5_;
	_tmp6_ = util_timezone_from_ical (date);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_date_time_new (_tmp7_, year, month, day, hour, minute, (gdouble) second);
	_tmp9_ = _tmp8_;
	_g_time_zone_unref0 (_tmp7_);
	result = _tmp9_;
	return result;
}

/**
     * Say if an event lasts all day.
     */
gboolean
util_is_the_all_day (GDateTime* dtstart,
                     GDateTime* dtend)
{
	GDateTime* utc_start = NULL;
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GTimeSpan timespan = 0LL;
	gboolean _tmp4_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (dtstart != NULL, FALSE);
	g_return_val_if_fail (dtend != NULL, FALSE);
	_tmp0_ = g_time_zone_new_utc ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_date_time_to_timezone (dtstart, _tmp1_);
	_tmp3_ = _tmp2_;
	_g_time_zone_unref0 (_tmp1_);
	utc_start = _tmp3_;
	timespan = g_date_time_difference (dtend, dtstart);
	if ((timespan % G_TIME_SPAN_DAY) == ((GTimeSpan) 0)) {
		GDateTime* _tmp5_;
		_tmp5_ = utc_start;
		_tmp4_ = g_date_time_get_hour (_tmp5_) == 0;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		result = TRUE;
		_g_date_time_unref0 (utc_start);
		return result;
	} else {
		result = FALSE;
		_g_date_time_unref0 (utc_start);
		return result;
	}
	_g_date_time_unref0 (utc_start);
}

void
util_set_event_calendar_color (ESourceCalendar* cal,
                               GtkWidget* widget)
{
	GeeHashMap* _tmp0_;
	gchar* color = NULL;
	gchar* _tmp2_;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp16_;
	GeeHashMap* _tmp17_;
	const gchar* _tmp18_;
	gpointer _tmp19_;
	GtkCssProvider* _tmp20_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (cal != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = util_providers;
	if (_tmp0_ == NULL) {
		GeeHashMap* _tmp1_;
		_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, gtk_css_provider_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
		_g_object_unref0 (util_providers);
		util_providers = _tmp1_;
	}
	_tmp2_ = e_source_selectable_dup_color ((ESourceSelectable*) cal);
	color = _tmp2_;
	_tmp3_ = util_providers;
	_tmp4_ = color;
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, _tmp4_)) {
		gchar* style = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = color;
		_tmp6_ = g_strdup_printf ("\n                @define-color colorAccent %s;\n            ", _tmp5_);
		style = _tmp6_;
		{
			GtkCssProvider* style_provider = NULL;
			GtkCssProvider* _tmp7_;
			GtkCssProvider* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			GeeHashMap* _tmp13_;
			const gchar* _tmp14_;
			GtkCssProvider* _tmp15_;
			_tmp7_ = gtk_css_provider_new ();
			style_provider = _tmp7_;
			_tmp8_ = style_provider;
			_tmp9_ = style;
			_tmp10_ = style;
			_tmp11_ = strlen (_tmp10_);
			_tmp12_ = _tmp11_;
			gtk_css_provider_load_from_data (_tmp8_, _tmp9_, (gssize) _tmp12_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (style_provider);
				goto __catch0_g_error;
			}
			_tmp13_ = util_providers;
			_tmp14_ = color;
			_tmp15_ = style_provider;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, _tmp14_, _tmp15_);
			_g_object_unref0 (style_provider);
		}
		goto __finally0;
		__catch0_g_error:
		{
			g_clear_error (&_inner_error0_);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (style);
			_g_free0 (color);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_free0 (style);
	}
	_tmp16_ = gtk_widget_get_style_context (widget);
	style_context = _tmp16_;
	_tmp17_ = util_providers;
	_tmp18_ = color;
	_tmp19_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp17_, _tmp18_);
	_tmp20_ = (GtkCssProvider*) _tmp19_;
	gtk_style_context_add_provider (style_context, (GtkStyleProvider*) _tmp20_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_g_object_unref0 (_tmp20_);
	_g_free0 (color);
}

guint
util_source_hash_func (ESource* key)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	guint _tmp2_;
	guint result = 0U;
	g_return_val_if_fail (key != NULL, 0U);
	_tmp0_ = e_source_dup_uid (key);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_str_hash (_tmp1_);
	_g_free0 (_tmp1_);
	result = _tmp2_;
	return result;
}

static void
_vala_ECalComponentId_free (ECalComponentId* self)
{
	g_boxed_free (e_cal_component_id_get_type (), self);
}

gboolean
util_calcomponent_equal_func (ECalComponent* a,
                              ECalComponent* b)
{
	ECalComponentId* _tmp0_;
	ECalComponentId* _tmp1_;
	ECalComponentId* _tmp2_;
	ECalComponentId* _tmp3_;
	gboolean _tmp4_;
	gboolean result = FALSE;
	g_return_val_if_fail (a != NULL, FALSE);
	g_return_val_if_fail (b != NULL, FALSE);
	_tmp0_ = e_cal_component_get_id (a);
	_tmp1_ = _tmp0_;
	_tmp2_ = e_cal_component_get_id (b);
	_tmp3_ = _tmp2_;
	_tmp4_ = e_cal_component_id_equal (_tmp1_, _tmp3_);
	__vala_ECalComponentId_free0 (_tmp3_);
	__vala_ECalComponentId_free0 (_tmp1_);
	result = _tmp4_;
	return result;
}

gint
util_calcomponent_compare_func (ECalComponent* a,
                                ECalComponent* b)
{
	gboolean _tmp0_ = FALSE;
	ECalComponentId* a_id = NULL;
	ECalComponentId* _tmp3_;
	ECalComponentId* b_id = NULL;
	ECalComponentId* _tmp4_;
	gint res = 0;
	GCompareFunc _tmp5_;
	ECalComponentId* _tmp6_;
	const gchar* _tmp7_;
	ECalComponentId* _tmp8_;
	const gchar* _tmp9_;
	gint result = 0;
	if (a == NULL) {
		_tmp0_ = b != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = 1;
		return result;
	} else {
		gboolean _tmp1_ = FALSE;
		if (b == NULL) {
			_tmp1_ = a != NULL;
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			result = -1;
			return result;
		} else {
			gboolean _tmp2_ = FALSE;
			if (b == NULL) {
				_tmp2_ = a == NULL;
			} else {
				_tmp2_ = FALSE;
			}
			if (_tmp2_) {
				result = 0;
				return result;
			}
		}
	}
	_tmp3_ = e_cal_component_get_id (a);
	a_id = _tmp3_;
	_tmp4_ = e_cal_component_get_id (b);
	b_id = _tmp4_;
	_tmp5_ = ((GCompareFunc) g_strcmp0);
	_tmp6_ = a_id;
	_tmp7_ = e_cal_component_id_get_uid (_tmp6_);
	_tmp8_ = b_id;
	_tmp9_ = e_cal_component_id_get_uid (_tmp8_);
	res = _tmp5_ (_tmp7_, _tmp9_);
	if (res == 0) {
		GCompareFunc _tmp10_;
		ECalComponentId* _tmp11_;
		const gchar* _tmp12_;
		ECalComponentId* _tmp13_;
		const gchar* _tmp14_;
		_tmp10_ = ((GCompareFunc) g_strcmp0);
		_tmp11_ = a_id;
		_tmp12_ = e_cal_component_id_get_rid (_tmp11_);
		_tmp13_ = b_id;
		_tmp14_ = e_cal_component_id_get_rid (_tmp13_);
		result = _tmp10_ (_tmp12_, _tmp14_);
		__vala_ECalComponentId_free0 (b_id);
		__vala_ECalComponentId_free0 (a_id);
		return result;
	}
	result = res;
	__vala_ECalComponentId_free0 (b_id);
	__vala_ECalComponentId_free0 (a_id);
	return result;
}

gboolean
util_calcomp_is_on_day (ECalComponent* comp,
                        GDateTime* day)
{
	ICalTimezone* system_timezone = NULL;
	ICalTimezone* _tmp0_;
	GDateTime* stripped_time = NULL;
	GDateTime* _tmp1_;
	gint64 selected_date_unix = 0LL;
	GDateTime* _tmp2_;
	gint64 selected_date_unix_next = 0LL;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	gint64 _tmp6_;
	ICalComponent* icomp = NULL;
	ICalComponent* _tmp7_;
	ICalTime* start_time = NULL;
	ICalComponent* _tmp8_;
	ICalTime* _tmp9_;
	ICalTime* end_time = NULL;
	ICalComponent* _tmp10_;
	ICalTime* _tmp11_;
	time_t start_unix = 0;
	ICalTime* _tmp12_;
	ICalTimezone* _tmp13_;
	time_t end_unix = 0;
	ICalTime* _tmp14_;
	ICalTimezone* _tmp15_;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (comp != NULL, FALSE);
	g_return_val_if_fail (day != NULL, FALSE);
	_tmp0_ = e_cal_util_get_system_timezone ();
	system_timezone = _tmp0_;
	_tmp1_ = g_date_time_new_local (g_date_time_get_year (day), g_date_time_get_month (day), g_date_time_get_day_of_month (day), 0, 0, (gdouble) 0);
	stripped_time = _tmp1_;
	_tmp2_ = stripped_time;
	selected_date_unix = g_date_time_to_unix (_tmp2_);
	_tmp3_ = stripped_time;
	_tmp4_ = g_date_time_add_days (_tmp3_, 1);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_date_time_to_unix (_tmp5_);
	_g_date_time_unref0 (_tmp5_);
	selected_date_unix_next = _tmp6_;
	_tmp7_ = e_cal_component_get_icalcomponent (comp);
	icomp = _tmp7_;
	_tmp8_ = icomp;
	_tmp9_ = i_cal_component_get_dtstart (_tmp8_);
	start_time = _tmp9_;
	_tmp10_ = icomp;
	_tmp11_ = i_cal_component_get_dtend (_tmp10_);
	end_time = _tmp11_;
	_tmp12_ = start_time;
	_tmp13_ = system_timezone;
	start_unix = (time_t) i_cal_time_as_timet_with_zone (_tmp12_, _tmp13_);
	_tmp14_ = end_time;
	_tmp15_ = system_timezone;
	end_unix = (time_t) i_cal_time_as_timet_with_zone (_tmp14_, _tmp15_);
	if (((gint64) start_unix) < selected_date_unix) {
		_tmp16_ = selected_date_unix_next < ((gint64) end_unix);
	} else {
		_tmp16_ = FALSE;
	}
	if (_tmp16_) {
		result = TRUE;
		_g_object_unref0 (end_time);
		_g_object_unref0 (start_time);
		_g_date_time_unref0 (stripped_time);
		return result;
	}
	if (((gint64) start_unix) < selected_date_unix) {
		_tmp17_ = selected_date_unix < ((gint64) end_unix);
	} else {
		_tmp17_ = FALSE;
	}
	if (_tmp17_) {
		result = TRUE;
		_g_object_unref0 (end_time);
		_g_object_unref0 (start_time);
		_g_date_time_unref0 (stripped_time);
		return result;
	}
	if (((gint64) start_unix) < selected_date_unix_next) {
		_tmp18_ = selected_date_unix_next < ((gint64) end_unix);
	} else {
		_tmp18_ = FALSE;
	}
	if (_tmp18_) {
		result = TRUE;
		_g_object_unref0 (end_time);
		_g_object_unref0 (start_time);
		_g_date_time_unref0 (stripped_time);
		return result;
	}
	if (((gint64) start_unix) < selected_date_unix_next) {
		_tmp19_ = selected_date_unix < ((gint64) end_unix);
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		result = TRUE;
		_g_object_unref0 (end_time);
		_g_object_unref0 (start_time);
		_g_date_time_unref0 (stripped_time);
		return result;
	}
	result = FALSE;
	_g_object_unref0 (end_time);
	_g_object_unref0 (start_time);
	_g_date_time_unref0 (stripped_time);
	return result;
}

gboolean
util_source_equal_func (ESource* a,
                        ESource* b)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean result = FALSE;
	g_return_val_if_fail (a != NULL, FALSE);
	g_return_val_if_fail (b != NULL, FALSE);
	_tmp0_ = e_source_dup_uid (a);
	_tmp1_ = _tmp0_;
	_tmp2_ = e_source_dup_uid (b);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strcmp0 (_tmp1_, _tmp3_) == 0;
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	result = _tmp4_;
	return result;
}

static void
util_reset_timer_data_free (gpointer _data)
{
	UtilResetTimerData* _data_;
	_data_ = _data;
	g_slice_free (UtilResetTimerData, _data_);
}

void
util_reset_timer (GAsyncReadyCallback _callback_,
                  gpointer _user_data_)
{
	UtilResetTimerData* _data_;
	_data_ = g_slice_new0 (UtilResetTimerData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, util_reset_timer_data_free);
	util_reset_timer_co (_data_);
}

void
util_reset_timer_finish (GAsyncResult* _res_)
{
	UtilResetTimerData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
__lambda1017_ (void)
{
	gboolean result = FALSE;
	util_has_scrolled = FALSE;
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda1017__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda1017_ ();
	return result;
}

static gboolean
util_reset_timer_co (UtilResetTimerData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	util_has_scrolled = TRUE;
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ___lambda1017__gsource_func, NULL, NULL);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

gchar*
util_get_source_location (ESource* source)
{
	ESourceRegistry* registry = NULL;
	ServicesCalendarCalendarModel* _tmp0_;
	ESourceRegistry* _tmp1_;
	ESourceRegistry* _tmp2_;
	ESourceRegistry* _tmp3_;
	gchar* parent_uid = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	ESource* parent_source = NULL;
	ESource* _tmp7_;
	gchar* _tmp39_;
	gchar* result = NULL;
	g_return_val_if_fail (source != NULL, NULL);
	_tmp0_ = planner_calendar_model;
	_tmp1_ = services_calendar_calendar_model_get_registry (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	registry = _tmp3_;
	_tmp4_ = e_source_get_parent (source);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strdup (_tmp5_);
	parent_uid = _tmp6_;
	_tmp7_ = _g_object_ref0 (source);
	parent_source = _tmp7_;
	while (TRUE) {
		ESource* _tmp8_;
		ESource* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		ESource* _tmp13_;
		ESource* _tmp24_;
		const gchar* _tmp35_;
		ESourceRegistry* _tmp36_;
		const gchar* _tmp37_;
		ESource* _tmp38_;
		_tmp8_ = parent_source;
		if (!(_tmp8_ != NULL)) {
			break;
		}
		_tmp9_ = parent_source;
		_tmp10_ = e_source_get_parent (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_strdup (_tmp11_);
		_g_free0 (parent_uid);
		parent_uid = _tmp12_;
		_tmp13_ = parent_source;
		if (e_source_has_extension (_tmp13_, E_SOURCE_EXTENSION_AUTHENTICATION)) {
			ESourceAuthentication* collection = NULL;
			ESource* _tmp14_;
			ESourceExtension* _tmp15_;
			ESourceAuthentication* _tmp16_;
			ESourceAuthentication* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			_tmp14_ = parent_source;
			_tmp15_ = e_source_get_extension (_tmp14_, E_SOURCE_EXTENSION_AUTHENTICATION);
			_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, e_source_authentication_get_type (), ESourceAuthentication));
			collection = _tmp16_;
			_tmp17_ = collection;
			_tmp18_ = e_source_authentication_get_user (_tmp17_);
			_tmp19_ = _tmp18_;
			if (_tmp19_ != NULL) {
				ESourceAuthentication* _tmp20_;
				const gchar* _tmp21_;
				const gchar* _tmp22_;
				gchar* _tmp23_;
				_tmp20_ = collection;
				_tmp21_ = e_source_authentication_get_user (_tmp20_);
				_tmp22_ = _tmp21_;
				_tmp23_ = g_strdup (_tmp22_);
				result = _tmp23_;
				_g_object_unref0 (collection);
				_g_object_unref0 (parent_source);
				_g_free0 (parent_uid);
				_g_object_unref0 (registry);
				return result;
			}
			_g_object_unref0 (collection);
		}
		_tmp24_ = parent_source;
		if (e_source_has_extension (_tmp24_, E_SOURCE_EXTENSION_COLLECTION)) {
			ESourceCollection* collection = NULL;
			ESource* _tmp25_;
			ESourceExtension* _tmp26_;
			ESourceCollection* _tmp27_;
			ESourceCollection* _tmp28_;
			const gchar* _tmp29_;
			const gchar* _tmp30_;
			_tmp25_ = parent_source;
			_tmp26_ = e_source_get_extension (_tmp25_, E_SOURCE_EXTENSION_COLLECTION);
			_tmp27_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, e_source_collection_get_type (), ESourceCollection));
			collection = _tmp27_;
			_tmp28_ = collection;
			_tmp29_ = e_source_collection_get_identity (_tmp28_);
			_tmp30_ = _tmp29_;
			if (_tmp30_ != NULL) {
				ESourceCollection* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gchar* _tmp34_;
				_tmp31_ = collection;
				_tmp32_ = e_source_collection_get_identity (_tmp31_);
				_tmp33_ = _tmp32_;
				_tmp34_ = g_strdup (_tmp33_);
				result = _tmp34_;
				_g_object_unref0 (collection);
				_g_object_unref0 (parent_source);
				_g_free0 (parent_uid);
				_g_object_unref0 (registry);
				return result;
			}
			_g_object_unref0 (collection);
		}
		_tmp35_ = parent_uid;
		if (_tmp35_ == NULL) {
			break;
		}
		_tmp36_ = registry;
		_tmp37_ = parent_uid;
		_tmp38_ = e_source_registry_ref_source (_tmp36_, _tmp37_);
		_g_object_unref0 (parent_source);
		parent_source = _tmp38_;
	}
	_tmp39_ = g_strdup (_ ("On this computer"));
	result = _tmp39_;
	_g_object_unref0 (parent_source);
	_g_free0 (parent_uid);
	_g_object_unref0 (registry);
	return result;
}

