/* ProjectProgress.c generated by valac 0.48.12, the Vala compiler
 * generated from ProjectProgress.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; c-basic-offset: 4; tab-width: 4 -*- */
/* vim: set tabstop=4 softtabstop=4 shiftwidth=4 expandtab : */
/*
 * CircularProgressBar.vala
 *
 * Custom Gtk.Widget to provide a circular progress bar.
 * It extends/subclasses Gtk.Bin instead of Gtk.DrawingArea.
 *
 * Colors, font and some parameters could move onto CSS but for simplicity will be kept inline.
 * Minimum size is hardcoded on min_d. Minimum line width is 1.
 *
 * José Miguel Fonte
 * https://github.com/phastmike/vala-circular-progress-bar
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>

#define WIDGETS_TYPE_PROJECT_PROGRESS (widgets_project_progress_get_type ())
#define WIDGETS_PROJECT_PROGRESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_PROJECT_PROGRESS, WidgetsProjectProgress))
#define WIDGETS_PROJECT_PROGRESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_PROJECT_PROGRESS, WidgetsProjectProgressClass))
#define WIDGETS_IS_PROJECT_PROGRESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_PROJECT_PROGRESS))
#define WIDGETS_IS_PROJECT_PROGRESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_PROJECT_PROGRESS))
#define WIDGETS_PROJECT_PROGRESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_PROJECT_PROGRESS, WidgetsProjectProgressClass))

typedef struct _WidgetsProjectProgress WidgetsProjectProgress;
typedef struct _WidgetsProjectProgressClass WidgetsProjectProgressClass;
typedef struct _WidgetsProjectProgressPrivate WidgetsProjectProgressPrivate;
enum  {
	WIDGETS_PROJECT_PROGRESS_0_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_MIN_D_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_CENTER_FILLED_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_RADIUS_FILLED_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_FONT_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_LINE_CAP_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_CENTER_FILL_COLOR_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_RADIUS_FILL_COLOR_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_PROGRESS_FILL_COLOR_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_LINE_WIDTH_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_PERCENTAGE_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_NUM_PROPERTIES
};
static GParamSpec* widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _WidgetsProjectProgress {
	GtkBin parent_instance;
	WidgetsProjectProgressPrivate * priv;
};

struct _WidgetsProjectProgressClass {
	GtkBinClass parent_class;
};

struct _WidgetsProjectProgressPrivate {
	gint _min_d;
	gint _line_width;
	gdouble _percentage;
	gchar* _center_fill_color;
	gchar* _radius_fill_color;
	gchar* _progress_fill_color;
	gboolean _center_filled;
	gboolean _radius_filled;
	gchar* _font;
	cairo_line_cap_t _line_cap;
};

static gint WidgetsProjectProgress_private_offset;
static gpointer widgets_project_progress_parent_class = NULL;

GType widgets_project_progress_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WidgetsProjectProgress, g_object_unref)
WidgetsProjectProgress* widgets_project_progress_new (gint min_d);
WidgetsProjectProgress* widgets_project_progress_construct (GType object_type,
                                                            gint min_d);
static void __lambda220_ (WidgetsProjectProgress* self);
static void ___lambda220__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static gint widgets_project_progress_calculate_radius (WidgetsProjectProgress* self);
static gint widgets_project_progress_calculate_diameter (WidgetsProjectProgress* self);
static GtkSizeRequestMode widgets_project_progress_real_get_request_mode (GtkWidget* base);
static void widgets_project_progress_real_get_preferred_width (GtkWidget* base,
                                                        gint* min_w,
                                                        gint* natural_w);
gint widgets_project_progress_get_min_d (WidgetsProjectProgress* self);
static void widgets_project_progress_real_get_preferred_height (GtkWidget* base,
                                                         gint* min_h,
                                                         gint* natural_h);
static void widgets_project_progress_real_size_allocate (GtkWidget* base,
                                                  GtkAllocation* allocation);
static gboolean widgets_project_progress_real_draw (GtkWidget* base,
                                             cairo_t* cr);
gint widgets_project_progress_get_line_width (WidgetsProjectProgress* self);
void widgets_project_progress_set_line_width (WidgetsProjectProgress* self,
                                              gint value);
cairo_line_cap_t widgets_project_progress_get_line_cap (WidgetsProjectProgress* self);
gboolean widgets_project_progress_get_center_filled (WidgetsProjectProgress* self);
const gchar* widgets_project_progress_get_center_fill_color (WidgetsProjectProgress* self);
gboolean widgets_project_progress_get_radius_filled (WidgetsProjectProgress* self);
const gchar* widgets_project_progress_get_radius_fill_color (WidgetsProjectProgress* self);
gdouble widgets_project_progress_get_percentage (WidgetsProjectProgress* self);
const gchar* widgets_project_progress_get_progress_fill_color (WidgetsProjectProgress* self);
static void widgets_project_progress_set_min_d (WidgetsProjectProgress* self,
                                         gint value);
void widgets_project_progress_set_center_filled (WidgetsProjectProgress* self,
                                                 gboolean value);
void widgets_project_progress_set_radius_filled (WidgetsProjectProgress* self,
                                                 gboolean value);
const gchar* widgets_project_progress_get_font (WidgetsProjectProgress* self);
void widgets_project_progress_set_font (WidgetsProjectProgress* self,
                                        const gchar* value);
void widgets_project_progress_set_line_cap (WidgetsProjectProgress* self,
                                            cairo_line_cap_t value);
void widgets_project_progress_set_center_fill_color (WidgetsProjectProgress* self,
                                                     const gchar* value);
void widgets_project_progress_set_radius_fill_color (WidgetsProjectProgress* self,
                                                     const gchar* value);
void widgets_project_progress_set_progress_fill_color (WidgetsProjectProgress* self,
                                                       const gchar* value);
void widgets_project_progress_set_percentage (WidgetsProjectProgress* self,
                                              gdouble value);
static GObject * widgets_project_progress_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void widgets_project_progress_finalize (GObject * obj);
static GType widgets_project_progress_get_type_once (void);
static void _vala_widgets_project_progress_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_widgets_project_progress_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
widgets_project_progress_get_instance_private (WidgetsProjectProgress* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsProjectProgress_private_offset);
}

static void
__lambda220_ (WidgetsProjectProgress* self)
{
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static void
___lambda220__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	__lambda220_ ((WidgetsProjectProgress*) self);
}

WidgetsProjectProgress*
widgets_project_progress_construct (GType object_type,
                                    gint min_d)
{
	WidgetsProjectProgress * self = NULL;
	self = (WidgetsProjectProgress*) g_object_new (object_type, "min-d", min_d, NULL);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) ___lambda220__g_object_notify, self, 0);
	return self;
}

WidgetsProjectProgress*
widgets_project_progress_new (gint min_d)
{
	return widgets_project_progress_construct (WIDGETS_TYPE_PROJECT_PROGRESS, min_d);
}

static gint
widgets_project_progress_calculate_radius (WidgetsProjectProgress* self)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = MIN (gtk_widget_get_allocated_width ((GtkWidget*) self) / 2, gtk_widget_get_allocated_height ((GtkWidget*) self) / 2) - 1;
	return result;
}

static gint
widgets_project_progress_calculate_diameter (WidgetsProjectProgress* self)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = 2 * widgets_project_progress_calculate_radius (self);
	return result;
}

static GtkSizeRequestMode
widgets_project_progress_real_get_request_mode (GtkWidget* base)
{
	WidgetsProjectProgress * self;
	GtkSizeRequestMode result = 0;
	self = (WidgetsProjectProgress*) base;
	result = GTK_SIZE_REQUEST_CONSTANT_SIZE;
	return result;
}

static void
widgets_project_progress_real_get_preferred_width (GtkWidget* base,
                                                   gint* min_w,
                                                   gint* natural_w)
{
	WidgetsProjectProgress * self;
	gint _vala_min_w = 0;
	gint _vala_natural_w = 0;
	gint d = 0;
	gint _tmp0_;
	gint _tmp1_;
	self = (WidgetsProjectProgress*) base;
	d = widgets_project_progress_calculate_diameter (self);
	_tmp0_ = self->priv->_min_d;
	_vala_min_w = _tmp0_;
	_tmp1_ = self->priv->_min_d;
	if (d > _tmp1_) {
		_vala_natural_w = d;
	} else {
		gint _tmp2_;
		_tmp2_ = self->priv->_min_d;
		_vala_natural_w = _tmp2_;
	}
	if (min_w) {
		*min_w = _vala_min_w;
	}
	if (natural_w) {
		*natural_w = _vala_natural_w;
	}
}

static void
widgets_project_progress_real_get_preferred_height (GtkWidget* base,
                                                    gint* min_h,
                                                    gint* natural_h)
{
	WidgetsProjectProgress * self;
	gint _vala_min_h = 0;
	gint _vala_natural_h = 0;
	gint d = 0;
	gint _tmp0_;
	gint _tmp1_;
	self = (WidgetsProjectProgress*) base;
	d = widgets_project_progress_calculate_diameter (self);
	_tmp0_ = self->priv->_min_d;
	_vala_min_h = _tmp0_;
	_tmp1_ = self->priv->_min_d;
	if (d > _tmp1_) {
		_vala_natural_h = d;
	} else {
		gint _tmp2_;
		_tmp2_ = self->priv->_min_d;
		_vala_natural_h = _tmp2_;
	}
	if (min_h) {
		*min_h = _vala_min_h;
	}
	if (natural_h) {
		*natural_h = _vala_natural_h;
	}
}

static void
widgets_project_progress_real_size_allocate (GtkWidget* base,
                                             GtkAllocation* allocation)
{
	WidgetsProjectProgress * self;
	GtkAllocation _tmp0_;
	self = (WidgetsProjectProgress*) base;
	g_return_if_fail (allocation != NULL);
	_tmp0_ = *allocation;
	GTK_WIDGET_CLASS (widgets_project_progress_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin), &_tmp0_);
}

static gboolean
widgets_project_progress_real_draw (GtkWidget* base,
                                    cairo_t* cr)
{
	WidgetsProjectProgress * self;
	gint delta = 0;
	GdkRGBA color = {0};
	gint center_x = 0;
	gint center_y = 0;
	gint radius = 0;
	gint _tmp0_;
	gint _tmp1_;
	cairo_line_cap_t _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp11_;
	gdouble _tmp15_;
	gdouble _tmp16_;
	gboolean result = FALSE;
	self = (WidgetsProjectProgress*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	cairo_save (cr);
	memset (&color, 0, sizeof (GdkRGBA));
	center_x = gtk_widget_get_allocated_width ((GtkWidget*) self) / 2;
	center_y = gtk_widget_get_allocated_height ((GtkWidget*) self) / 2;
	radius = widgets_project_progress_calculate_radius (self);
	_tmp0_ = widgets_project_progress_get_line_width (self);
	_tmp1_ = _tmp0_;
	if ((radius - _tmp1_) < 0) {
		delta = 0;
		widgets_project_progress_set_line_width (self, radius);
	} else {
		gint _tmp2_;
		gint _tmp3_;
		_tmp2_ = widgets_project_progress_get_line_width (self);
		_tmp3_ = _tmp2_;
		delta = radius - (_tmp3_ / 2);
	}
	memset (&color, 0, sizeof (GdkRGBA));
	_tmp4_ = self->priv->_line_cap;
	cairo_set_line_cap (cr, _tmp4_);
	_tmp5_ = widgets_project_progress_get_line_width (self);
	_tmp6_ = _tmp5_;
	cairo_set_line_width (cr, (gdouble) _tmp6_);
	_tmp7_ = self->priv->_center_filled;
	if (_tmp7_ == TRUE) {
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		GdkRGBA _tmp10_;
		cairo_arc (cr, (gdouble) center_x, (gdouble) center_y, (gdouble) delta, (gdouble) 0, 2 * G_PI);
		_tmp8_ = widgets_project_progress_get_center_fill_color (self);
		_tmp9_ = _tmp8_;
		gdk_rgba_parse (&color, _tmp9_);
		_tmp10_ = color;
		gdk_cairo_set_source_rgba (cr, &_tmp10_);
		cairo_fill (cr);
	}
	_tmp11_ = self->priv->_radius_filled;
	if (_tmp11_ == TRUE) {
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		GdkRGBA _tmp14_;
		cairo_arc (cr, (gdouble) center_x, (gdouble) center_y, (gdouble) delta, (gdouble) 0, 2 * G_PI);
		_tmp12_ = widgets_project_progress_get_radius_fill_color (self);
		_tmp13_ = _tmp12_;
		gdk_rgba_parse (&color, _tmp13_);
		_tmp14_ = color;
		gdk_cairo_set_source_rgba (cr, &_tmp14_);
		cairo_stroke (cr);
	}
	_tmp15_ = widgets_project_progress_get_percentage (self);
	_tmp16_ = _tmp15_;
	if (_tmp16_ > ((gdouble) 0)) {
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		GdkRGBA _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		_tmp17_ = widgets_project_progress_get_progress_fill_color (self);
		_tmp18_ = _tmp17_;
		gdk_rgba_parse (&color, _tmp18_);
		_tmp19_ = color;
		gdk_cairo_set_source_rgba (cr, &_tmp19_);
		_tmp20_ = widgets_project_progress_get_line_width (self);
		_tmp21_ = _tmp20_;
		if (_tmp21_ == 0) {
			gdouble _tmp22_;
			gdouble _tmp23_;
			cairo_move_to (cr, (gdouble) center_x, (gdouble) center_y);
			_tmp22_ = widgets_project_progress_get_percentage (self);
			_tmp23_ = _tmp22_;
			cairo_arc (cr, (gdouble) center_x, (gdouble) center_y, (gdouble) (delta + 1), 1.5 * G_PI, (1.5 + (_tmp23_ * 2)) * G_PI);
			cairo_fill (cr);
		} else {
			gdouble _tmp24_;
			gdouble _tmp25_;
			_tmp24_ = widgets_project_progress_get_percentage (self);
			_tmp25_ = _tmp24_;
			cairo_arc (cr, (gdouble) center_x, (gdouble) center_y, (gdouble) delta, 1.5 * G_PI, (1.5 + (_tmp25_ * 2)) * G_PI);
			cairo_stroke (cr);
		}
	}
	cairo_restore (cr);
	result = GTK_WIDGET_CLASS (widgets_project_progress_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin), cr);
	return result;
}

gint
widgets_project_progress_get_min_d (WidgetsProjectProgress* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_min_d;
	return result;
}

static void
widgets_project_progress_set_min_d (WidgetsProjectProgress* self,
                                    gint value)
{
	g_return_if_fail (self != NULL);
	if (widgets_project_progress_get_min_d (self) != value) {
		self->priv->_min_d = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_MIN_D_PROPERTY]);
	}
}

gboolean
widgets_project_progress_get_center_filled (WidgetsProjectProgress* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_center_filled;
	return result;
}

void
widgets_project_progress_set_center_filled (WidgetsProjectProgress* self,
                                            gboolean value)
{
	g_return_if_fail (self != NULL);
	if (widgets_project_progress_get_center_filled (self) != value) {
		self->priv->_center_filled = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_CENTER_FILLED_PROPERTY]);
	}
}

gboolean
widgets_project_progress_get_radius_filled (WidgetsProjectProgress* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_radius_filled;
	return result;
}

void
widgets_project_progress_set_radius_filled (WidgetsProjectProgress* self,
                                            gboolean value)
{
	g_return_if_fail (self != NULL);
	if (widgets_project_progress_get_radius_filled (self) != value) {
		self->priv->_radius_filled = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_RADIUS_FILLED_PROPERTY]);
	}
}

const gchar*
widgets_project_progress_get_font (WidgetsProjectProgress* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_font;
	result = _tmp0_;
	return result;
}

void
widgets_project_progress_set_font (WidgetsProjectProgress* self,
                                   const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, widgets_project_progress_get_font (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_font);
		self->priv->_font = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_FONT_PROPERTY]);
	}
}

cairo_line_cap_t
widgets_project_progress_get_line_cap (WidgetsProjectProgress* self)
{
	cairo_line_cap_t result;
	cairo_line_cap_t _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_line_cap;
	result = _tmp0_;
	return result;
}

void
widgets_project_progress_set_line_cap (WidgetsProjectProgress* self,
                                       cairo_line_cap_t value)
{
	g_return_if_fail (self != NULL);
	if (widgets_project_progress_get_line_cap (self) != value) {
		self->priv->_line_cap = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_LINE_CAP_PROPERTY]);
	}
}

const gchar*
widgets_project_progress_get_center_fill_color (WidgetsProjectProgress* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_center_fill_color;
	result = _tmp0_;
	return result;
}

void
widgets_project_progress_set_center_fill_color (WidgetsProjectProgress* self,
                                                const gchar* value)
{
	GdkRGBA color = {0};
	g_return_if_fail (self != NULL);
	memset (&color, 0, sizeof (GdkRGBA));
	if (gdk_rgba_parse (&color, value)) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_center_fill_color);
		self->priv->_center_fill_color = _tmp0_;
	}
	g_object_notify_by_pspec ((GObject *) self, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_CENTER_FILL_COLOR_PROPERTY]);
}

const gchar*
widgets_project_progress_get_radius_fill_color (WidgetsProjectProgress* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_radius_fill_color;
	result = _tmp0_;
	return result;
}

void
widgets_project_progress_set_radius_fill_color (WidgetsProjectProgress* self,
                                                const gchar* value)
{
	GdkRGBA color = {0};
	g_return_if_fail (self != NULL);
	memset (&color, 0, sizeof (GdkRGBA));
	if (gdk_rgba_parse (&color, value)) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_radius_fill_color);
		self->priv->_radius_fill_color = _tmp0_;
	}
	g_object_notify_by_pspec ((GObject *) self, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_RADIUS_FILL_COLOR_PROPERTY]);
}

const gchar*
widgets_project_progress_get_progress_fill_color (WidgetsProjectProgress* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_progress_fill_color;
	result = _tmp0_;
	return result;
}

void
widgets_project_progress_set_progress_fill_color (WidgetsProjectProgress* self,
                                                  const gchar* value)
{
	GdkRGBA color = {0};
	g_return_if_fail (self != NULL);
	memset (&color, 0, sizeof (GdkRGBA));
	if (gdk_rgba_parse (&color, value)) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_progress_fill_color);
		self->priv->_progress_fill_color = _tmp0_;
	}
	g_object_notify_by_pspec ((GObject *) self, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_PROGRESS_FILL_COLOR_PROPERTY]);
}

gint
widgets_project_progress_get_line_width (WidgetsProjectProgress* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_line_width;
	return result;
}

void
widgets_project_progress_set_line_width (WidgetsProjectProgress* self,
                                         gint value)
{
	g_return_if_fail (self != NULL);
	if (value < 0) {
		self->priv->_line_width = 0;
	} else {
		self->priv->_line_width = value;
	}
	g_object_notify_by_pspec ((GObject *) self, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_LINE_WIDTH_PROPERTY]);
}

gdouble
widgets_project_progress_get_percentage (WidgetsProjectProgress* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_percentage;
	return result;
}

void
widgets_project_progress_set_percentage (WidgetsProjectProgress* self,
                                         gdouble value)
{
	g_return_if_fail (self != NULL);
	if (value > 1.0) {
		self->priv->_percentage = 1.0;
	} else {
		if (value < 0.0) {
			self->priv->_percentage = 0.0;
		} else {
			self->priv->_percentage = value;
		}
	}
	g_object_notify_by_pspec ((GObject *) self, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_PERCENTAGE_PROPERTY]);
}

static GObject *
widgets_project_progress_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsProjectProgress * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	parent_class = G_OBJECT_CLASS (widgets_project_progress_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_PROJECT_PROGRESS, WidgetsProjectProgress);
	self->priv->_line_width = 0;
	self->priv->_percentage = (gdouble) 0;
	_tmp0_ = g_strdup ("#adadad");
	_g_free0 (self->priv->_center_fill_color);
	self->priv->_center_fill_color = _tmp0_;
	_tmp1_ = g_strdup ("#d3d3d3");
	_g_free0 (self->priv->_radius_fill_color);
	self->priv->_radius_fill_color = _tmp1_;
	_tmp2_ = g_strdup ("#4a90d9");
	_g_free0 (self->priv->_progress_fill_color);
	self->priv->_progress_fill_color = _tmp2_;
	return obj;
}

static void
widgets_project_progress_class_init (WidgetsProjectProgressClass * klass,
                                     gpointer klass_data)
{
	widgets_project_progress_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WidgetsProjectProgress_private_offset);
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) widgets_project_progress_real_get_request_mode;
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) widgets_project_progress_real_get_preferred_width;
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) widgets_project_progress_real_get_preferred_height;
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) widgets_project_progress_real_size_allocate;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) widgets_project_progress_real_draw;
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_project_progress_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_project_progress_set_property;
	G_OBJECT_CLASS (klass)->constructor = widgets_project_progress_constructor;
	G_OBJECT_CLASS (klass)->finalize = widgets_project_progress_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PROJECT_PROGRESS_MIN_D_PROPERTY, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_MIN_D_PROPERTY] = g_param_spec_int ("min-d", "min-d", "min-d", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PROJECT_PROGRESS_CENTER_FILLED_PROPERTY, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_CENTER_FILLED_PROPERTY] = g_param_spec_boolean ("center-filled", "Center Fill", "Center Fill toggle", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PROJECT_PROGRESS_RADIUS_FILLED_PROPERTY, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_RADIUS_FILLED_PROPERTY] = g_param_spec_boolean ("radius-filled", "Radius Fill", "Radius Fill toggle", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PROJECT_PROGRESS_FONT_PROPERTY, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_FONT_PROPERTY] = g_param_spec_string ("font", "Font", "Font description without size, just the font name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PROJECT_PROGRESS_LINE_CAP_PROPERTY, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_LINE_CAP_PROPERTY] = g_param_spec_enum ("line-cap", "Line Cap", "Line Cap for stroke as in Cairo.LineCap", cairo_gobject_line_cap_get_type (), CAIRO_LINE_CAP_BUTT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PROJECT_PROGRESS_CENTER_FILL_COLOR_PROPERTY, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_CENTER_FILL_COLOR_PROPERTY] = g_param_spec_string ("center-fill-color", "Inside circle fill color", "Center pad fill color (Check Gdk.RGBA parse method)", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PROJECT_PROGRESS_RADIUS_FILL_COLOR_PROPERTY, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_RADIUS_FILL_COLOR_PROPERTY] = g_param_spec_string ("radius-fill-color", "Circular radius fill color", "The circular pad fill color (Check GdkRGBA parse method)", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PROJECT_PROGRESS_PROGRESS_FILL_COLOR_PROPERTY, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_PROGRESS_FILL_COLOR_PROPERTY] = g_param_spec_string ("progress-fill-color", "Progress fill color", "Progress line color (Check GdkRGBA parse method)", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PROJECT_PROGRESS_LINE_WIDTH_PROPERTY, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_LINE_WIDTH_PROPERTY] = g_param_spec_int ("line-width", "Circle width", "The circle radius line width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PROJECT_PROGRESS_PERCENTAGE_PROPERTY, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_PERCENTAGE_PROPERTY] = g_param_spec_double ("percentage", "Percentage/Value", "The percentage value [0.0 ... 1.0]", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
widgets_project_progress_instance_init (WidgetsProjectProgress * self,
                                        gpointer klass)
{
	gchar* _tmp0_;
	self->priv = widgets_project_progress_get_instance_private (self);
	self->priv->_center_filled = FALSE;
	self->priv->_radius_filled = FALSE;
	_tmp0_ = g_strdup ("URW Gothic");
	self->priv->_font = _tmp0_;
	self->priv->_line_cap = CAIRO_LINE_CAP_BUTT;
}

static void
widgets_project_progress_finalize (GObject * obj)
{
	WidgetsProjectProgress * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_PROJECT_PROGRESS, WidgetsProjectProgress);
	_g_free0 (self->priv->_center_fill_color);
	_g_free0 (self->priv->_radius_fill_color);
	_g_free0 (self->priv->_progress_fill_color);
	_g_free0 (self->priv->_font);
	G_OBJECT_CLASS (widgets_project_progress_parent_class)->finalize (obj);
}

static GType
widgets_project_progress_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsProjectProgressClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_project_progress_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsProjectProgress), 0, (GInstanceInitFunc) widgets_project_progress_instance_init, NULL };
	GType widgets_project_progress_type_id;
	widgets_project_progress_type_id = g_type_register_static (gtk_bin_get_type (), "WidgetsProjectProgress", &g_define_type_info, 0);
	WidgetsProjectProgress_private_offset = g_type_add_instance_private (widgets_project_progress_type_id, sizeof (WidgetsProjectProgressPrivate));
	return widgets_project_progress_type_id;
}

GType
widgets_project_progress_get_type (void)
{
	static volatile gsize widgets_project_progress_type_id__volatile = 0;
	if (g_once_init_enter (&widgets_project_progress_type_id__volatile)) {
		GType widgets_project_progress_type_id;
		widgets_project_progress_type_id = widgets_project_progress_get_type_once ();
		g_once_init_leave (&widgets_project_progress_type_id__volatile, widgets_project_progress_type_id);
	}
	return widgets_project_progress_type_id__volatile;
}

static void
_vala_widgets_project_progress_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	WidgetsProjectProgress * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_PROJECT_PROGRESS, WidgetsProjectProgress);
	switch (property_id) {
		case WIDGETS_PROJECT_PROGRESS_MIN_D_PROPERTY:
		g_value_set_int (value, widgets_project_progress_get_min_d (self));
		break;
		case WIDGETS_PROJECT_PROGRESS_CENTER_FILLED_PROPERTY:
		g_value_set_boolean (value, widgets_project_progress_get_center_filled (self));
		break;
		case WIDGETS_PROJECT_PROGRESS_RADIUS_FILLED_PROPERTY:
		g_value_set_boolean (value, widgets_project_progress_get_radius_filled (self));
		break;
		case WIDGETS_PROJECT_PROGRESS_FONT_PROPERTY:
		g_value_set_string (value, widgets_project_progress_get_font (self));
		break;
		case WIDGETS_PROJECT_PROGRESS_LINE_CAP_PROPERTY:
		g_value_set_enum (value, widgets_project_progress_get_line_cap (self));
		break;
		case WIDGETS_PROJECT_PROGRESS_CENTER_FILL_COLOR_PROPERTY:
		g_value_set_string (value, widgets_project_progress_get_center_fill_color (self));
		break;
		case WIDGETS_PROJECT_PROGRESS_RADIUS_FILL_COLOR_PROPERTY:
		g_value_set_string (value, widgets_project_progress_get_radius_fill_color (self));
		break;
		case WIDGETS_PROJECT_PROGRESS_PROGRESS_FILL_COLOR_PROPERTY:
		g_value_set_string (value, widgets_project_progress_get_progress_fill_color (self));
		break;
		case WIDGETS_PROJECT_PROGRESS_LINE_WIDTH_PROPERTY:
		g_value_set_int (value, widgets_project_progress_get_line_width (self));
		break;
		case WIDGETS_PROJECT_PROGRESS_PERCENTAGE_PROPERTY:
		g_value_set_double (value, widgets_project_progress_get_percentage (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_widgets_project_progress_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	WidgetsProjectProgress * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_PROJECT_PROGRESS, WidgetsProjectProgress);
	switch (property_id) {
		case WIDGETS_PROJECT_PROGRESS_MIN_D_PROPERTY:
		widgets_project_progress_set_min_d (self, g_value_get_int (value));
		break;
		case WIDGETS_PROJECT_PROGRESS_CENTER_FILLED_PROPERTY:
		widgets_project_progress_set_center_filled (self, g_value_get_boolean (value));
		break;
		case WIDGETS_PROJECT_PROGRESS_RADIUS_FILLED_PROPERTY:
		widgets_project_progress_set_radius_filled (self, g_value_get_boolean (value));
		break;
		case WIDGETS_PROJECT_PROGRESS_FONT_PROPERTY:
		widgets_project_progress_set_font (self, g_value_get_string (value));
		break;
		case WIDGETS_PROJECT_PROGRESS_LINE_CAP_PROPERTY:
		widgets_project_progress_set_line_cap (self, g_value_get_enum (value));
		break;
		case WIDGETS_PROJECT_PROGRESS_CENTER_FILL_COLOR_PROPERTY:
		widgets_project_progress_set_center_fill_color (self, g_value_get_string (value));
		break;
		case WIDGETS_PROJECT_PROGRESS_RADIUS_FILL_COLOR_PROPERTY:
		widgets_project_progress_set_radius_fill_color (self, g_value_get_string (value));
		break;
		case WIDGETS_PROJECT_PROGRESS_PROGRESS_FILL_COLOR_PROPERTY:
		widgets_project_progress_set_progress_fill_color (self, g_value_get_string (value));
		break;
		case WIDGETS_PROJECT_PROGRESS_LINE_WIDTH_PROPERTY:
		widgets_project_progress_set_line_width (self, g_value_get_int (value));
		break;
		case WIDGETS_PROJECT_PROGRESS_PERCENTAGE_PROPERTY:
		widgets_project_progress_set_percentage (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

